# Class VulkanExtent3D.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanExtent3D.Builder

Enclosing class:
  `VulkanExtent3D`

public static final class VulkanExtent3D.Builder extends Object
Builds instances of type `VulkanExtent3D`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanExtent3D`
  `build()`
  Builds a new `VulkanExtent3D`.
  `final VulkanExtent3D.Builder`
  `from(VulkanExtent3DType instance)`
  Fill a builder with attribute values from the provided `VulkanExtent3DType` instance.
  `final VulkanExtent3D.Builder`
  `setDepth(int depth)`
  Initializes the value for the `depth` attribute.
  `final VulkanExtent3D.Builder`
  `setHeight(int height)`
  Initializes the value for the `height` attribute.
  `final VulkanExtent3D.Builder`
  `setWidth(int width)`
  Initializes the value for the `width` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanExtent3D.Builder from(VulkanExtent3DType instance)
    Fill a builder with attribute values from the provided `VulkanExtent3DType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setWidth

    public final VulkanExtent3D.Builder setWidth(int width)
    Initializes the value for the `width` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `width`.

    Parameters:
      `width` - The value for width
    Returns:
      `this` builder for use in a chained invocation

  - ### setHeight

    public final VulkanExtent3D.Builder setHeight(int height)
    Initializes the value for the `height` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `height`.

    Parameters:
      `height` - The value for height
    Returns:
      `this` builder for use in a chained invocation

  - ### setDepth

    public final VulkanExtent3D.Builder setDepth(int depth)
    Initializes the value for the `depth` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `depth`.

    Parameters:
      `depth` - The value for depth
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanExtent3D build()
    Builds a new `VulkanExtent3D`.
    Returns:
      An immutable instance of VulkanExtent3D
    Throws:
      `IllegalStateException` - if any required attributes are missing